#---
# Excerpted from "Using memcached: How to scale your website easily",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
#---

#!/usr/bin/perl
use strict;
use DBI;
use Cache::Memcached;

# Set the server list up
my $memd = new Cache::Memcached {'servers' => [ "127.0.0.1:11211"],};
$memd->set_compress_threshold(1_000);
$memd->enable_compress(1);

use Time::HiRes qw( gettimeofday tv_interval);

# DBI configuration
my $dsn = "DBI:mysql:memcachedTesting:localhost";
my $user = "mcd";	#Notice, not root
my $pw = "n0pass";	#Notice, password 
my $table = "";

my $Counter = 0;
# Loop 
while ($Counter<100)
{
  my $start = [gettimeofday];


  #Check memcached
  my $data = $memd->get("CalendarOfEvents");
  if (not $data) { 
  # Connect to server and database
  my $dbh = DBI->connect($dsn, $user, $pw);
  my $statement = "select EventID, EventDate, Description, Details
	from calendarofevents where WebSiteID = 1";
  my $key_field = "EventID";
  $data = $dbh->selectall_hashref($statement, $key_field);
  $memd->set("CalendarOfEvents", $data);
  }
  #Whether from memcached or from the database, I have a hashref to parse
  $table = "<table border=1>";
  while( my ($k, $v) = each %$data ) {
	$table = $table . "<tr><td>"
	.$v->{EventDate}."</td><td><a href=BookReservation.html?EventID="
	.$v->{EventID}.">".$v->{Description}."</a><br />"
	.$v->{Details}."</td></tr>\r\n"; 
    }
  $table = $table . "</table>";

my $end = time;
$Counter = $Counter + 1;
}

print $table

