#!/usr/bin/perl
#---
# Excerpted from "Using memcached: How to scale your website easily",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/memcd for more book information.
#---
use strict;
use DBI;
use Cache::Memcached;

use Digest::SHA qw(sha512_base64);


# Set the server list up
my $memd = new Cache::Memcached {'servers' => [ "127.0.0.1:11211"],};
$memd->set_compress_threshold(1_000);
$memd->enable_compress(1);

# DBI configuration
my $dsn = "DBI:mysql:memcachedTesting:localhost";
my $user = "mcd";	#Notice, not root
my $pw = "n0pass";	#Notice, password 

my $table = "";
$table = &GetCalendarOfEvents(1);
print $table;


sub GetCalendarOfEvents
{
my $WebSiteID = shift;
my $tableKey = sha512_base64("CalendarOfEvents:HTMLTable:".$WebSiteID);
my $table = $memd->get($tableKey);	#Look for the HTML Table
  my $statement = "select EventID, EventDate, Description, Details ".
     "from calendarofevents where WebSiteID = ".$WebSiteID;
  my $dataKey = sha512_base64($statement);

if (not $table) {
  print "going to memcached for data object\n";
  my $data = $memd->get($dataKey);
  if (not $data) { # Connect to server and database
      print "going to database\n";
    my $dbh = DBI->connect($dsn, $user, $pw);
    my $key_field = "EventID";
    $data = $dbh->selectall_hashref($statement, $key_field);
    $memd->set($dataKey, $data);
  } #end not $data

  #Whether from memcached or from the database, I have a hashref to parse
  $table = "<table border=1>";
  while( my ($k, $v) = each %$data ) {
	$table = $table . "<tr><td>"
	.$v->{EventDate}."</td><td><a href=BookReservation.html?EventID="
	.$v->{EventID}.">".$v->{Description}."</a><br />"
	.$v->{Details}."</td></tr>\r\n"; 
  } #end while loop through %data
  $table = $table . "</table>";
  $memd->set($tableKey, $table);
 } #end not $table
$table;
}


